#!/usr/bin/env python

from numpy.testing import *

from numpy import median, dot, squeeze, zeros
from numpy.random import rand, randint
from numpy.linalg import inv

import fff2.misc as fm

class test_all(NumpyTestCase):

    def check_median(self):
        x = rand(100)
        assert_almost_equal(fm.median(x), median(x))

    def check_median2(self):
        x = rand(101)
        assert_equal(fm.median(x), median(x))

    def check_median3(self):
        x = rand(10,30,11)
        assert_almost_equal(squeeze(fm.median(x,axis=1)), median(x,axis=1))

    def check_mahalanobis(self):
        x = rand(100)
        A = rand(100,100)
        A = dot(A.transpose(), A)
        mah = dot(x, dot(inv(A), x))
        assert_almost_equal(mah, fm.mahalanobis(x, A)) 
        
    def check_mahalanobis2(self):
        x = rand(100,3,4)
        Aa = zeros([100,100,3,4])
        for i in range(3):
            for j in range(4):
                A = rand(100,100)
                A = dot(A.transpose(), A)
                Aa[:,:,i,j] = A
        i = randint(3)
        j = randint(4)
        mah = dot(x[:,i,j], dot(inv(Aa[:,:,i,j]), x[:,i,j]))
        f_mah = (fm.mahalanobis(x, Aa))[i,j]        
        assert_almost_equal(mah, f_mah)
        
if __name__ == "__main__":
    NumpyTest().run()
